function useTool(pos, playerIndex)
	local emitter = game.findentitiesfiltered({area = {{x = pos.x - toolRadius, y = pos.y - toolRadius}, {x = pos.x + toolRadius, y = pos.y + toolRadius}}, name = emitterName})
	if #emitter ~= 0 then
		local emitterTable = findEmitter(emitter[1])
		if emitterTable ~= nil then
			showEmitterGui(emitterTable, playerIndex)
		end
	end
end

game.onevent(defines.events.onguiclick, function(event)
	if guiNames[event.element.name] then
		guiNames[event.element.name](event)
	end
end)

function showEmitterGui(emitterTable, playerIndex)
	local GUICenter = game.players[playerIndex].gui.center
	local canOpenGUI = true
	if glob.emitterConfigGUIs ~= nil then
		for index,player in pairs(game.players) do
			--if index ~= playerIndex then
				if glob.emitterConfigGUIs["I" .. index] ~= nil and glob.emitterConfigGUIs["I" .. index][1] == emitterTable then
					game.players[playerIndex].print(player.name .. " (player " .. index .. ") has the GUI for this emitter open right now.")
					canOpenGUI = false
				end
			--end
		end
	end
	
	if canOpenGUI and GUICenter and GUICenter.emitterConfig == nil then
		local frame = GUICenter.add({type = "frame", name = "emitterConfig", caption = game.getlocalisedentityname(emitterName), direction = "vertical", style = frame_caption_label_style})
		local configTable = frame.add({type ="table", name = "emitterConfigTable", colspan = 2})
		configTable.add({type = "label", name = "directionLabel", caption = "Direction:                       "})
		local directions = configTable.add({type = "table", name = "directions", colspan = 4})
		
		local d1Style = "selectbuttons"
		local d2Style = "selectbuttons"
		local d3Style = "selectbuttons"
		local d4Style = "selectbuttons"
		if emitterTable["10"] == defines.direction.north then
			d1Style = "selectbuttonsselected"
		elseif emitterTable["10"] == defines.direction.south then
			d2Style = "selectbuttonsselected"
		elseif emitterTable["10"] == defines.direction.east then
			d3Style = "selectbuttonsselected"
		elseif emitterTable["10"] == defines.direction.south then
			d4Style = "selectbuttonsselected"
		end
		directions.add({type = "button", name = "directionN", caption = "N", style = d1Style})
		directions.add({type = "button", name = "directionS", caption = "S", style = d2Style})
		directions.add({type = "button", name = "directionE", caption = "E", style = d3Style})
		directions.add({type = "button", name = "directionW", caption = "W", style = d4Style})
		
		configTable.add({type = "label", name = "fieldTypeLabel", caption = "Field type:"})
		local fields = configTable.add({type = "table", name = "fields", colspan = 4})
		local f1Style = "selectbuttons"
		local f2Style = "selectbuttons"
		local f3Style = "selectbuttons"
		local f4Style = "selectbuttons"
		if emitterTable["9"] == "blue" .. fieldSuffix then
			f1Style = "selectbuttonsselected"
		elseif emitterTable["9"] == "green" .. fieldSuffix then
			f2Style = "selectbuttonsselected"
		elseif emitterTable["9"] == "red" .. fieldSuffix then
			f3Style = "selectbuttonsselected"
		elseif emitterTable["9"] == "purple" .. fieldSuffix then
			f4Style = "selectbuttonsselected"
		end
		fields.add({type = "button", name = "fieldB", caption = "B", style = f1Style})
		fields.add({type = "button", name = "fieldG", caption = "G", style = f2Style})
		fields.add({type = "button", name = "fieldR", caption = "R", style = f3Style})
		fields.add({type = "button", name = "fieldP", caption = "P", style = f4Style})
		
		-- Non-functional at the moment due to bugs with setting .style in Multiplayer
		--[[
		local d1 = directions.add({type = "button", name = "directionN", caption = "N", style = "selectbuttons"})
		local d2 = directions.add({type = "button", name = "directionS", caption = "S", style = "selectbuttons"})
		local d3 = directions.add({type = "button", name = "directionE", caption = "E", style = "selectbuttons"})
		local d4 = directions.add({type = "button", name = "directionW", caption = "W", style = "selectbuttons"})
		
		if emitterTable[10] == defines.direction.north then
			d1.style = "selectbuttonsselected"
		elseif emitterTable[10] == defines.direction.south then
			d2.style = "selectbuttonsselected"
		elseif emitterTable[10] == defines.direction.east then
			d3.style = "selectbuttonsselected"
		elseif emitterTable[10] == defines.direction.south then
			d4.style = "selectbuttonsselected"
		end
		
		configTable.add({type = "label", name = "fieldTypeLabel", caption = "Field type:"})
		local fields = configTable.add({type = "table", name = "fields", colspan = 4})
		local f1 = fields.add({type = "button", name = "fieldB", caption = "B", style = "selectbuttons"})
		local f2 = fields.add({type = "button", name = "fieldG", caption = "G", style = "selectbuttons"})
		local f3 = fields.add({type = "button", name = "fieldR", caption = "R", style = "selectbuttons"})
		local f4 = fields.add({type = "button", name = "fieldP", caption = "P", style = "selectbuttons"})
		
		if emitterTable[9] == "blue" .. fieldSuffix then
			f1.style = "selectbuttonsselected"
		elseif emitterTable[9] == "green" .. fieldSuffix then
			f2.style = "selectbuttonsselected"
		elseif emitterTable[9] == "red" .. fieldSuffix then
			f3.style = "selectbuttonsselected"
		elseif emitterTable[9] == "purple" .. fieldSuffix then
			f4.style = "selectbuttonsselected"
		end
		--]]
		
		configTable.add({type = "label", name = "distanceLabel", caption = "Emitter distance:"})
		local distance = configTable.add({type = "table", name = "distance", colspan = 2})
		distance.add({type = "textfield", name = "emitterDistance", style = "distancetext"}).text = emitterTable["7"]
		distance.add({type = "label", name = "emitterMaxDistance", caption = "Max: " .. tostring(emitterDefaultDistance + getEmitterBonusDistance(emitterTable)), style = "description_title_label_style"})
		configTable.add({type = "label", name = "currentWidthLabel", caption = "Emitter width:"})
		local width = configTable.add({type = "table", name = "width", colspan = 2})
		width.add({type = "textfield", name = "emitterWidth", style = "distancetext"}).text = emitterTable["6"]
		width.add({type = "label", name = "emitterMaxWidth", caption = "Max: " .. tostring(emitterDefaultWidth + getEmitterBonusWidth(emitterTable)), style = "description_title_label_style"})
		configTable.add({type = "label", name = "upgradesLabel", caption = "Upgrades applied:"})
		
		local upgrades = configTable.add({type = "table", name = "upgrades", colspan = 2})
		if emitterTable["12"] ~= 0 then
			upgrades.add({type = "button", name = "distanceUpgrades", caption = "x" .. tostring(emitterTable["12"]), style = "advanced-circuit"})
		else
			upgrades.add({type = "button", name = "distanceUpgrades", caption = "", style = "noitem"})
		end
		if emitterTable["13"] ~= 0 then
			upgrades.add({type = "button", name = "widthUpgrades", caption = "x" .. tostring(emitterTable["13"]), style = "processing-unit"})
		else
			upgrades.add({type = "button", name = "widthUpgrades", caption = "", style = "noitem"})
		end
		
		frame.add({type = "button", name = "emitterHelpButton", caption = "?"})
		frame.add({type = "button", name = "removeAllButton", caption = "Remove all upgrades"})
		frame.add({type = "button", name = "applyButton", caption = "Apply"})
		
		if glob.emitterConfigGUIs == nil then
			glob.emitterConfigGUIs = {}
		end
		
		glob.emitterConfigGUIs["I" .. playerIndex] = {}
		glob.emitterConfigGUIs["I" .. playerIndex][1] = emitterTable
	end
end

local guiNames =
{
	["directionN"] = handleGUIDirectionButtons,
	["directionS"] = handleGUIDirectionButtons,
	["directionE"] = handleGUIDirectionButtons,
	["directionW"] = handleGUIDirectionButtons,

	["fieldB"] = handleGUIFieldTypeButtons,
	["fieldG"] = handleGUIFieldTypeButtons,
	["fieldR"] = handleGUIFieldTypeButtons,
	["fieldP"] = handleGUIFieldTypeButtons,

	["distanceUpgrades"] = handleGUIUpgradeButtons,
	["widthUpgrades"] = handleGUIUpgradeButtons,

	["emitterHelpButton"] = handleGUIMenuButtons,
	["removeAllButton"] = handleGUIMenuButtons,
	["applyButton"] = handleGUIMenuButtons
}

function handleGUIDirectionButtons(event)
	local frame = game.players[event.element.playerindex].gui.center.emitterConfig
	local nameToDirection = {["directionN"] = defines.direction.north, ["directionS"] = defines.direction.south, ["directionE"] = defines.direction.east, ["directionW"] = defines.direction.west}
	
	if frame ~= nil then
		local directions = frame.emitterConfigTable.directions
		glob.emitterConfigGUIs["I" .. event.element.playerindex][2] = nameToDirection[event.element.name]
		
		--broken in 0.11.3
		--directions.directionN.style = "selectbuttons"
		--directions.directionS.style = "selectbuttons"
		--directions.directionE.style = "selectbuttons"
		--directions.directionW.style = "selectbuttons"
		--directions[event.element.name].style = "selectbuttonsselected"
		
		-- Work-around
		local selectedButtonName = event.element.name
		directions.directionN.destroy()
		directions.directionS.destroy()
		directions.directionE.destroy()
		directions.directionW.destroy()
		
		local d1Style = "selectbuttons"
		local d2Style = "selectbuttons"
		local d3Style = "selectbuttons"
		local d4Style = "selectbuttons"
		if selectedButtonName == "directionN" then
			d1Style = "selectbuttonsselected"
		elseif selectedButtonName == "directionS" then
			d2Style = "selectbuttonsselected"
		elseif selectedButtonName == "directionE" then
			d3Style = "selectbuttonsselected"
		elseif selectedButtonName == "directionW" then
			d4Style = "selectbuttonsselected"
		end
		directions.add({type = "button", name = "directionN", caption = "N", style = d1Style})
		directions.add({type = "button", name = "directionS", caption = "S", style = d2Style})
		directions.add({type = "button", name = "directionE", caption = "E", style = d3Style})
		directions.add({type = "button", name = "directionW", caption = "W", style = d4Style})
	end
end

function handleGUIFieldTypeButtons(event)
	local frame = game.players[event.element.playerindex].gui.center.emitterConfig
	local nameToFieldName = {["fieldB"] = "blue" .. fieldSuffix, ["fieldG"] = "green" .. fieldSuffix, ["fieldR"] = "red" .. fieldSuffix, ["fieldP"] = "purple" .. fieldSuffix}
	if frame ~= nil then
		local fields = frame.emitterConfigTable.fields
		local shouldSwitch = true
		
		--Broken in 0.11.3
		--fields.fieldB.style = "selectbuttons"
		--fields.fieldG.style = "selectbuttons"
		--fields.fieldR.style = "selectbuttons"
		--fields.fieldP.style = "selectbuttons"
		--fields[event.element.name].style = "selectbuttonsselected"
		
		-- Work around
		local selectedButtonName = event.element.name
		local f1Style = "selectbuttons"
		local f2Style = "selectbuttons"
		local f3Style = "selectbuttons"
		local f4Style = "selectbuttons"
		if selectedButtonName == "fieldB" then
			f1Style = "selectbuttonsselected"
		elseif selectedButtonName == "fieldG" then
			shouldSwitch = game.forces.player.technologies["green-fields"].researched
			f2Style = "selectbuttonsselected"
		elseif selectedButtonName == "fieldR" then
			shouldSwitch = game.forces.player.technologies["red-fields"].researched
			f3Style = "selectbuttonsselected"
		elseif selectedButtonName == "fieldP" then
			shouldSwitch = game.forces.player.technologies["purple-fields"].researched
			f4Style = "selectbuttonsselected"
		end
		
		if shouldSwitch then
			glob.emitterConfigGUIs["I" .. event.element.playerindex][3] = nameToFieldName[event.element.name]
			fields.fieldB.destroy()
			fields.fieldG.destroy()
			fields.fieldR.destroy()
			fields.fieldP.destroy()
			fields.add({type = "button", name = "fieldB", caption = "B", style = f1Style})
			fields.add({type = "button", name = "fieldG", caption = "G", style = f2Style})
			fields.add({type = "button", name = "fieldR", caption = "R", style = f3Style})
			fields.add({type = "button", name = "fieldP", caption = "P", style = f4Style})
		else
			game.players[event.element.playerindex].print("You need to complete research before this field type can be used.")
		end
	end
end

function handleGUIUpgradeButtons(event)
	local player = game.players[event.element.playerindex]
	local frame = player.gui.center.emitterConfig
	local nameToStyle = {["distanceUpgrades"] = "advanced-circuit", ["widthUpgrades"] = "processing-unit"}
	local styleToName = {["advanced-circuit"] = "distanceUpgrades", ["processing-unit"] = "widthUpgrades"}
	local nameToUpgradeLimit = {["distanceUpgrades"] = maxRangeUpgrades, ["widthUpgrades"] = maxWidthUpgrades}
	
	if frame ~= nil then
		local upgrades = frame.emitterConfigTable.upgrades
		local upgradeButton
		local count
		
		if player.cursorstack ~= nil then
			local stack = player.cursorstack
			
			if styleToName[stack.name] ~= nil then
				upgradeButton = upgrades[styleToName[stack.name]]
				if upgradeButton.caption ~= "" then
					count = tonumber(string.sub(upgradeButton.caption, 2)) + 1
				else
					count = 1
				end
				
				if count <= nameToUpgradeLimit[upgradeButton.name] then
					upgradeButton.caption = "x" .. tostring(count)
					updateMaxLabel(frame, upgradeButton)
					
					if count == 1 then
						--Broken in 0.11.3
						--upgradeButton.style = nameToStyle[upgradeButton.name]
						
						-- Work-around
						local distanceCaption = upgrades.distanceUpgrades.caption
						local widthCaption = upgrades.widthUpgrades.caption
						local distanceStyle
						local widthStyle
						upgrades.distanceUpgrades.destroy()
						upgrades.widthUpgrades.destroy()
						
						if distanceCaption == "" then
							distanceStyle = "noitem"
						else
							distanceStyle = "advanced-circuit"
						end
						if widthCaption == "" then
							widthStyle = "noitem"
						else
							widthStyle = "processing-unit"
						end
						
						upgrades.add({type = "button", name = "distanceUpgrades", caption = distanceCaption, style = distanceStyle})
						upgrades.add({type = "button", name = "widthUpgrades", caption = widthCaption, style = widthStyle})
					end
					
					stack.count = stack.count - 1
					if stack.count == 0 then
						player.cursorstack = nil
					else
						player.cursorstack = stack
					end
				else
					game.players[event.element.playerindex].print("Maximum upgrades of this type already installed.")
				end
			end
		else
			upgradeButton = upgrades[event.element.name]
			
			if upgradeButton.caption ~= "" then
				count = tonumber(string.sub(upgradeButton.caption, 2)) - 1
				if count == 0 then
					--Broken in 0.11.3
					--upgradeButton.style = "noitem"
					upgradeButton.caption = ""
					
					-- Work-around
					local distanceCaption = upgrades.distanceUpgrades.caption
					local widthCaption = upgrades.widthUpgrades.caption
					local whichButton = upgradeButton.name
					local distanceStyle
					local widthStyle
					upgrades.distanceUpgrades.destroy()
					upgrades.widthUpgrades.destroy()
					
					if distanceCaption == "" then
						distanceStyle = "noitem"
					else
						distanceStyle = "advanced-circuit"
					end
					if widthCaption == "" then
						widthStyle = "noitem"
					else
						widthStyle = "processing-unit"
					end
					
					upgrades.add({type = "button", name = "distanceUpgrades", caption = distanceCaption, style = distanceStyle})
					upgrades.add({type = "button", name = "widthUpgrades", caption = widthCaption, style = widthStyle})
					upgradeButton = upgrades[whichButton]
				else
					upgradeButton.caption = "x" .. tostring(count)
				end
				
				updateMaxLabel(frame, upgradeButton)
				transferToPlayer(player, {name = nameToStyle[upgradeButton.name], count = 1})
			end
		end
	end
end

function removeAllUpgrades(event)
	local frame = game.players[event.element.playerindex].gui.center.emitterConfig

	if frame then -- This shouldn't ever be required but won't hurt to check
		if glob.emitterConfigGUIs ~= nil
			and glob.emitterConfigGUIs["I" .. event.element.playerindex] ~= nil
			and glob.emitterConfigGUIs["I" .. event.element.playerindex][1]["1"].valid then
			
			local upgrades = frame.emitterConfigTable.upgrades
			local count
			local buttonName
			for itemName,button in pairs({["advanced-circuit"] = upgrades.distanceUpgrades, ["processing-unit"] = upgrades.widthUpgrades}) do
				if button.caption ~= "" then
					count = tonumber(string.sub(button.caption, 2))
					--bugged in 0.11.3
					--button.caption = ""
					--button.style = "noitem"
					
					buttonName = button.name
					button.destroy()
					button = upgrades.add({type = "button", name = buttonName, caption = "", style = "noitem"})
					
					updateMaxLabel(frame, button)
					transferToPlayer(game.players[event.element.playerindex], {name = itemName, count = count})
				end
			end
		else
			if glob.emitterConfigGUIs ~= nil and glob.emitterConfigGUIs["I" .. event.element.playerindex] ~= nil then
				glob.emitterConfigGUIs["I" .. event.element.playerindex] = nil
				if tableIsEmpty(glob.emitterConfigGUIs) then
					glob.emitterConfigGUIs = nil
				end
			end
			frame.destroy()
		end
	end
end

function handleGUIMenuButtons(event)
	local frame = game.players[event.element.playerindex].gui.center.emitterConfig
	if frame ~= nil then
		if event.element.name == "applyButton" then
			if verifyAndSetFromGUI(event) then
				glob.emitterConfigGUIs["I" .. event.element.playerindex] = nil
				if tableIsEmpty(glob.emitterConfigGUIs) then
					glob.emitterConfigGUIs = nil
				end
				frame.destroy()
			end
		elseif event.element.name == "emitterHelpButton" then
			printGUIHelp(game.players[event.element.playerindex])
		elseif event.element.name == "removeAllButton" then
			removeAllUpgrades(event)
		end
	end
end

function printGUIHelp(player)
	player.print("Direction: the direction the emitter projects the forcefields in.")
	player.print("Field type: the type of forcefield the emitter projects:")
	player.print("    [B]lue: normal health, normal re-spawn, normal power usage.")
	player.print("    [G]reen: higher health, very slow re-spawn, below-normal power usage.")
	player.print("    [R]ed: normal health, slow re-spawn, very high power usage. Damages living things that directly attack them.")
	player.print("    [P]urple: low health, very slow re-spawn, high power usage. On death, heavily damages living things near-by.")
	player.print("Emitter distance: the distance from the emitter in the configured direction the fields are constructed.")
	player.print("Emitter width: the width of the field constructed by the emitter.")
	player.print("Upgrades applied: the distance (advanced circuit) and width (processing unit) upgrades applied to the emitter.")
	player.print("Help button: displays this information.")
	player.print("Remove all upgrades: removes all upgrades from the emitter.")
	player.print("Apply: saves and applies the settings to the emitter.")
end

function updateMaxLabel(frame, upgradeButton)
	local count
	if upgradeButton.caption == "" then
		count = 0
	else
		count = tonumber(string.sub(upgradeButton.caption, 2))
	end
	if upgradeButton.name == "distanceUpgrades" then
		frame.emitterConfigTable.distance.emitterMaxDistance.caption = "Max: " .. tostring(emitterDefaultDistance + count)
	else
		frame.emitterConfigTable.width.emitterMaxWidth.caption = "Max: " .. tostring(emitterDefaultWidth + (count * 4))
	end
end

function verifyAndSetFromGUI(event)
	local newDirection
	local newFieldType
	local newDistance
	local newWidth
	local maxDistance
	local maxWidth
	local newWidthUpgrades
	local newDistanceUpgrades
	local selectedButtonStyle = "selectbuttonsselected"
	local player = game.players[event.element.playerindex]
	local settingsAreGood = true
	local settingsChanged = false
	local frame = player.gui.center.emitterConfig
	local emitterConfigTable = frame.emitterConfigTable 
	local upgrades = emitterConfigTable.upgrades
	
	if glob.emitterConfigGUIs ~= nil
		and glob.emitterConfigGUIs["I" .. event.element.playerindex] ~= nil
		and glob.emitterConfigGUIs["I" .. event.element.playerindex][1]["1"].valid then
		
		local emitterTable = glob.emitterConfigGUIs["I" .. event.element.playerindex][1]
		
		if glob.emitterConfigGUIs["I" .. event.element.playerindex][2] ~= nil then
			newDirection = glob.emitterConfigGUIs["I" .. event.element.playerindex][2]
		else
			newDirection = emitterTable["10"]
		end
		
		if glob.emitterConfigGUIs["I" .. event.element.playerindex][3] ~= nil then
			newFieldType = glob.emitterConfigGUIs["I" .. event.element.playerindex][3]
		else
			newFieldType = emitterTable["9"]
		end
		
		newDistance = tonumber(emitterConfigTable.distance.emitterDistance.text)
		newWidth = tonumber(emitterConfigTable.width.emitterWidth.text)
		maxDistance = tonumber(string.sub(emitterConfigTable.distance.emitterMaxDistance.caption, 6))
		maxWidth = tonumber(string.sub(emitterConfigTable.width.emitterMaxWidth.caption, 6))
		if upgrades.distanceUpgrades.caption ~= "" then
			newDistanceUpgrades = tonumber(string.sub(upgrades.distanceUpgrades.caption, 2))
		else
			newDistanceUpgrades = 0
		end
		if upgrades.widthUpgrades.caption ~= "" then
			newWidthUpgrades = tonumber(string.sub(upgrades.widthUpgrades.caption, 2))
		else
			newWidthUpgrades = 0
		end
		
		
		if not newDistance then
			player.print("New Distance is not a valid number.")
			settingsAreGood = false
		elseif newDistance > maxDistance then
			player.print("New Distance is larger than the allowed maximum.")
			settingsAreGood = false
		elseif newDistance < 1 then
			player.print("New Distance is smaller than the allowed minimum (1).")
			settingsAreGood = false
		elseif math.floor(newDistance) ~= newDistance then
			player.print("New Distance is not a valid number (can't have decimals).")
			settingsAreGood = false
		end
		if not newWidth then
			player.print("New Width is not a valid number.")
			settingsAreGood = false
		elseif newWidth > maxWidth then
			player.print("New Width is larger than the allowed maximum.")
			settingsAreGood = false
		elseif newWidth < 1 then
			player.print("New Width is smaller than the allowed minimum (1).")
			settingsAreGood = false
		elseif math.floor(newWidth) ~= newWidth then
			player.print("New Width is not a valid number (can't have decimals).")
			settingsAreGood = false
		elseif (math.floor((newWidth - 1) / 2) * 2) + 1 ~= newWidth then
			player.print("New Width has to be an odd number.")
			emitterConfigTable.width.emitterWidth.text = tostring((math.floor((newWidth - 1) / 2) * 2) + 1)
			settingsAreGood = false
		end
		
		if settingsAreGood then
			if emitterTable["6"] ~= newWidth
				or emitterTable["7"] ~= newDistance
				or emitterTable["9"] ~= newFieldType
				or emitterTable["10"] ~= newDirection then
				
				degradeLinkedFields(emitterTable)
				emitterTable["3"] = nil
				emitterTable["6"] = newWidth
				emitterTable["7"] = newDistance
				emitterTable["9"] = newFieldType
				emitterTable["10"] = newDirection
				emitterTable["11"] = nil
				setActive(emitterTable, true)
			end
			
			emitterTable["12"] = newDistanceUpgrades
			emitterTable["13"] = newWidthUpgrades
			return true
		end
	else
		return true
	end
end

