function slipstreamMigration(current_version, new_version)
	if current_version == nil then
		c1, c2, c3 = 1, 0, 1 -- Versions earlier than 1.0.2 do not have a version variable.
	else
		_, _, c1, c2, c3 = string.match(current_version,"(%d)%.(%d)%.(%d)")
	end
	
	if c1 == 1 and c2 == 0 and c3 <= 1 then -- 1.0.2 migration - altered for 1.1.0
		glob.slipstream = {}
		
		c3 = 2
	end
	
	if c1 == 1 and c2 == 0 and c3 == 2 then -- 1.1.0 migration
		glob.slipstream.sschests = {} -- Remove existing slipstream and terminal chests tables.
		glob.slipstream.tchests = nil
	end
	
	glob.slipstream.version = new_version
	local message = "Slipstream Chests updated to" .. new_version .. "."
	game.player.print(message)
end
