data:extend(
{
  {
	type = "accumulator",
	name = "slipstream-chest-battery",
	icon = "__base__/graphics/icons/steel-chest.png",
	flags = {"placeable-neutral", "player-creation"},
	minable = {hardness = 0.2, mining_time = 0.5, result = "slipstream-chest-battery"},
	max_health = 150,
	corpse = "medium-remnants",
	collision_box = {{-0.4, -0.4}, {0.4, 0.4}},
	selection_box = {{-0.1, -0.1}, {0.1, 0.1}},
	energy_source =
	{
	  type = "electric",
	  buffer_capacity = "50kJ",
	  usage_priority = "secondary-input",
	  input_flow_limit = "120kW",
	  output_flow_limit = "0kW"
	},
	picture =
	{
	  filename = "__Slipstream__/graphics/slipstream-chest-battery.png",
	  priority = "extra-high",
	  width = 1,
	  height = 1,
	  --shift = {0.7, -0.2}
	},
	charge_animation =
	{
	  filename = "__Slipstream__/graphics/slipstream-chest-battery.png",
	  width = 1,
	  height = 1,
	  line_length = 1,
	  frame_count = 1,
	  shift = {0, 0},
	  animation_speed = 0.5
	},
	charge_cooldown = 0,
	charge_light = {intensity = 0, size = 0},
	discharge_animation =
	{
	  filename = "__Slipstream__/graphics/slipstream-chest-battery.png",
	  width = 1,
	  height = 1,
	  line_length = 1,
	  frame_count = 1,
	  shift = {0, 0},
	  animation_speed = 0.5
	},
	discharge_cooldown = 0,
	discharge_light = {intensity = 0, size = 0},
	working_sound =
	{
	  sound =
	  {
		filename = "__base__/sound/accumulator-working.ogg",
		volume = 1
	  },
	  idle_sound = {
		filename = "__base__/sound/accumulator-idle.ogg",
		volume = 0.4
	  },
	  max_sounds_per_type = 0
	},
  },
  {
	type = "container",
	name = "slipstream-chest-basic",
	icon = "__base__/graphics/icons/steel-chest.png",
	flags = {"placeable-neutral", "player-creation"},
	minable = {mining_time = 1, result = "slipstream-chest-basic"},
	max_health = 150,
	corpse = "small-remnants",
	open_sound = { filename = "__base__/sound/metallic-chest-open.ogg", volume=0.65 },
	close_sound = { filename = "__base__/sound/metallic-chest-close.ogg", volume = 0.7 },
	resistances =
	{
	  {
		type = "fire",
		percent = 90
	  }
	},
	collision_box = {{-0.35, -0.35}, {0.35, 0.35}},
	selection_box = {{-0.5, -0.5}, {0.5, 0.5}},
	fast_replaceable_group = "transport-belt",
	inventory_size = 48,
	picture =
	{
	  filename = "__base__/graphics/entity/steel-chest/steel-chest.png",
	  priority = "extra-high",
	  width = 48,
	  height = 34,
	  shift = {0.2, 0}
	}
  },
  {
    type = "logistic-container",
    name = "slipstream-chest-passive-provider",
    icon = "__base__/graphics/icons/logistic-chest-passive-provider.png",
    flags = {"placeable-player", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "slipstream-chest-passive-provider"},
    max_health = 150,
    corpse = "small-remnants",
    collision_box = {{-0.35, -0.35}, {0.35, 0.35}},
    selection_box = {{-0.5, -0.5}, {0.5, 0.5}},
    fast_replaceable_group = "transport-belt",
    inventory_size = 48,
    logistic_mode = "passive-provider",
    open_sound = { filename = "__base__/sound/metallic-chest-open.ogg", volume=0.65 },
    close_sound = { filename = "__base__/sound/metallic-chest-close.ogg", volume = 0.7 },
    picture =
    {
      filename = "__base__/graphics/entity/logistic-chest/logistic-chest-passive-provider.png",
      priority = "extra-high",
      width = 38,
      height = 32,
      shift = {0.1, 0}
    }
  },
  {
    type = "logistic-container",
    name = "slipstream-chest-active-provider",
    icon = "__base__/graphics/icons/logistic-chest-active-provider.png",
    flags = {"placeable-player", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "slipstream-chest-active-provider"},
    max_health = 150,
    corpse = "small-remnants",
    collision_box = {{-0.35, -0.35}, {0.35, 0.35}},
    selection_box = {{-0.5, -0.5}, {0.5, 0.5}},
    fast_replaceable_group = "transport-belt",
    inventory_size = 48,
    logistic_mode = "active-provider",
    open_sound = { filename = "__base__/sound/metallic-chest-open.ogg", volume=0.65 },
    close_sound = { filename = "__base__/sound/metallic-chest-close.ogg", volume = 0.7 },
    picture =
    {
      filename = "__base__/graphics/entity/logistic-chest/logistic-chest-active-provider.png",
      priority = "extra-high",
      width = 38,
      height = 32,
      shift = {0.1, 0}
    }
  },
  {
    type = "logistic-container",
    name = "slipstream-chest-requester",
    icon = "__base__/graphics/icons/logistic-chest-requester.png",
    flags = {"placeable-player", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "slipstream-chest-requester"},
    max_health = 150,
    corpse = "small-remnants",
    collision_box = {{-0.35, -0.35}, {0.35, 0.35}},
    selection_box = {{-0.5, -0.5}, {0.5, 0.5}},
    fast_replaceable_group = "transport-belt",
    inventory_size = 48,
    logistic_mode = "requester",
    open_sound = { filename = "__base__/sound/metallic-chest-open.ogg", volume=0.65 },
    close_sound = { filename = "__base__/sound/metallic-chest-close.ogg", volume = 0.7 },
    picture =
    {
      filename = "__base__/graphics/entity/logistic-chest/logistic-chest-requester.png",
      priority = "extra-high",
      width = 38,
      height = 32,
      shift = {0.1, 0}
    }
  }
})
